/*
    INDEX CSS

    Intenta ser responsive
    - Si es una pantalla pequeña mete una sola
        columna y no muestra el footer
    - De otra manera, muestra varias columnas
        tanto para la pagina general como para visualizar
        las tarjetas de los lugares
*/

/*  Se utiliza el selector universal para resetear
    margenes y rellenos
    También utilizamos el modelo a nivel de borde
    para calcular la anchura de cajas
    Es habitual en frameworks utilizar el alto y ancho
    de una caja contabilizando hasta su borde y utilizar
    el padding para casi todo en vez del margin ya que vas
    poder separar igualmente los elementos y dejar
    al padre el que separe los hijos y sea el quien controle
    su disposición
*/
* {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
}

a:link,
a:visited {
    text-decoration: none;
    color: inherit;
}

/*
    para utilizar las areas en grid con template-areas
*/
header {
    grid-area: header;
}

#subheader {
    grid-area: subheader;
}

nav {
    grid-area: nav;
}

main {
    grid-area: main;
}

footer {
    grid-area: footer;
}

/*
    place-items: sirve para  colocar los elementos
    dentro del datagrid pues es el shorthand
    de align-items y justify-items, por tanto el
    primer valor los alinea verticalmente y el segundo
    horizontalmente
    Utilizo en este caso vh porque así se ve igual en
    diferentes resoluciones y proporcional a lo mostrado
    verticalmente, da menos problemas de posicionamiento
    Por defecto se muestra la barra de navegacion abajo
    hasta pasar de un ancho(px) que se muestra lateral

*/
body {
    color: white;
    background-color: rgb(56, 55, 55);
    place-items: start center;
    display: grid;
    grid-template-areas:
        "header"
        "subheader"
        "main"
        "nav";
    grid-template-rows: 6vh 7vh auto 10vh;
    grid-template-columns: 1fr;
    gap: 20px;
    font-family: Roboto, 'Franklin Gothic Medium',
        'Arial Narrow', Arial, sans-serif;
}

/*
    aquí vamos a incluir la barra de navegación
    como los componentes por defecto los pongo
    ajustados a contenido ya que a priori no
    sabes donde se van a utilizar les especifico
    un ancho del 100% para que coja todo el contenedor
    padre
    * vemos que el alto no he puesto el 100% porque
    *   en este caso su posición es fixed y por tanto
    *   su flujo se sale del flujo normal y lo ajusto
    *   al tamaño de la fila del grid
*/
header {
    width: 100%;
    height: 6vh;
    position: fixed;
    z-index: 99;
}

/*
    Aquí vamos a incluir el filtro de los lugares
    También estará fijo por tanto tengo que posicionarlo
    con el top y darle la altura en base a los otros
    elementos del grid

    usamos flex para centrar el contenido aunque se puede
    usar otros metodos en este caso pero si en un futuro
    queremos cambiar esto es más fácil con flex

    Por ultimo uso z-index para que no haya problemas
    de visualización al solaparse con otros elementos

*/
#subheader {
    background-color: rgba(0, 0, 0, 0.837);
    position: fixed;
    z-index: 99;
    top: 6vh;
    padding: 10px;
    height: 7vh;
    width: 100%;
    display: flex;
    flex-direction: row;
    justify-content: center;
}

/*
    La barra de navegación le doy un minimo
    con respecto al body
    Esta vez esta fijo en la parte inferior
    si la pantalla es pequeña
*/
nav {
    width: 70%;
    position: fixed;
    bottom: 0;
    z-index: 100;
}

/*
    Va a ocupar siempre el 90%
    mientras sólo se visualice en pantallas
    medianas y pequeñas para aprovechar el
    espacio pero dejando un espacio a los lados
*/
main {
    width: 90%;
}

/*
    Aquí va otro datagrid esta vez sin áreas,
    solo indicamos las columnas necesarias
    y ya el datagrid calcula el tamaño
    Le ponemos un gap entre filas y columnas
*/
#cards {
    display: grid;
    grid-gap: 30px;
    grid-template-columns: 1fr 1fr;
}

/*
    Esto se podía hacer con javascript
    pero lo que hago es por defecto no
    visualizar ninguna tarjeta y solo
    aquellas que estan asociadas a una
    clase determinada
*/
.TravelPlace {
    display: none;
}

/*
    Para que funcione este truco debe haber
    una relacion de parentesco entre elementos
    Aqui se visualizan todas las tarjetas
    ya que el filtro es un elemento input radio
    y solo esta seleccionada una a la vez
*/
#subheader:has(#filterall:checked)~main .TravelPlace {
    display: flex;
}

/*
    aqui se visualizan los favoritos, es decir
    los que tengan esa clase asignada
    esta clase se agrega o manualmente o en mi caso
    al ser contenido dinámico en el javascript
*/
#subheader:has(#filterfavorite:checked)~main .TravelPlace.Favorite {
    display: flex;
}

#subheader:has(#filterunfavorite:checked)~main .TravelPlace.Unfavorite {
    display: flex;
}

footer {
    display: none;
}

/* pantallas enanas */
@media (min-width: 0px) and (max-width: 700px) {
    #cards {
        margin: auto;
        display: grid;
        grid-gap: 30px;
        grid-template-columns: auto;
    }
}

/* pantallas grandes */
@media (min-width: 1280px) {

    /*
        a partir de cierta dimension
        visualizo dos columnas
    */
    body {
        place-items: start center;
        grid-template-areas:
            "header header"
            "subheader subheader"
            "nav main"
            "footer footer";
        grid-template-columns: auto auto;
    }

    nav {
        position: sticky;
        width: fit-content;
        top: 7.5vh;
        left: 20px;
    }

    /*
        muestro 3 columnas de tarjetas
    */
    #cards {
        margin: auto;
        display: grid;
        grid-gap: 30px;
        grid-template-columns: 1fr 1fr 1fr;
    }

    /*
        Muestro el footer centrado y arriba
    */
    footer {
        display: flex;
        justify-content: center;
        width: 100%;
    }

}

/* pantallas extra */
@media (min-width: 1980px) {

    /*
        muestro 4 columnas de tarjetas
    */
    #cards {
        margin: auto;
        display: grid;
        grid-gap: 30px;
        grid-template-columns: 1fr 1fr 1fr 1fr;
    }
}